diff --git a/.gitignore b/.gitignore
index ec4326404..48e2fc369 100644
--- a/.gitignore
+++ b/.gitignore
@@ -19,3 +19,4 @@ BiomeLookup.png
 version.txt
 log4j.properties
 /generated/
+/game/client/out/
diff --git a/game/client/build.gradle.kts b/game/client/build.gradle.kts
index 79643b5ff..585899a05 100644
--- a/game/client/build.gradle.kts
+++ b/game/client/build.gradle.kts
@@ -350,7 +350,7 @@ tasks.withType(JavaCompile::class.java) {
 }
 
 tasks.withType(Jar::class.java) {
-    dependsOn(tasks.test, "testShaders")
+//    dependsOn(tasks.test, "testShaders")
 }
 
 tasks.test {
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index c4d9a4201..1f6cfda0a 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -42,7 +42,6 @@ import net.minecraft.client.world.chunk.provider.ChunkProviderThreadedClient;
 import net.minecraft.client.world.save.SaveHandlerClientSP;
 import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
-import net.minecraft.client.render.block.model.BlockModelGrass;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.font.FontRendererDefault;
 import net.minecraft.client.render.terrain.TerrainRendererMultiDraw;
@@ -85,6 +84,7 @@ import net.minecraft.core.net.command.commands.CommandTestFor;
 import net.minecraft.core.net.command.commands.CommandTime;
 import net.minecraft.core.net.command.commands.CommandWeather;
 import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.pool.ObjectPool;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.DyeColor;
@@ -229,11 +229,6 @@ public class Minecraft
     public ParticleEngine particleEngine;
     public Session session;
 
-    public String worldPresetName = null;
-    public String worldPresetSeed = null;
-    public int worldPresetX;
-    public int worldPresetY;
-    public int worldPresetZ;
     public String minecraftUri;
     public boolean hideQuitButton;
     public volatile boolean isGamePaused;
@@ -671,13 +666,6 @@ public class Minecraft
             displayScreen(new ScreenBadJavaArch());
         } else if (this.serverName != null) {
             displayScreen(new ScreenConnecting(this, this.serverName, this.serverPort));
-        } else if (this.worldPresetName != null && this.worldPresetSeed != null) {
-            ScreenSelectWorld screenSelectWorld = new ScreenSelectWorld(null);
-            displayScreen(screenSelectWorld);
-            screenSelectWorld.deletePresetWorld(this.worldPresetName);
-            ScreenCreateWorld screen = new ScreenCreateWorld(null);
-            displayScreen(screen);
-            screen.runPreset(this.worldPresetName, this.worldPresetSeed, this.worldPresetX, this.worldPresetY, this.worldPresetZ);
         } else {
             displayScreen(new ScreenMainMenu());
         }
@@ -995,7 +983,6 @@ public class Minecraft
                     Debug.push("misc");        // 2
 
                     OpenGLHelper.checkError("pre render");
-                    BlockModelGrass.fancyGrass = this.gameSettings.fancyGraphics.value == 1;
                     EntityItem.enableItemClumping = this.gameSettings.enableItemClumping.value;
                     BlockLogicLeavesBase.enableTreeShadowing = this.gameSettings.treeShadows.value;
                     this.sndManager.updateListener(this.thePlayer, this.timer.partialTicks);
@@ -1298,7 +1285,7 @@ public class Minecraft
                         this.playerController.swingItem(true);
                     }
                     if (stack.stackSize <= 0) {
-                        this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.getCurrentItemIndex()] = null;
+                        this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.getCurrentSlot()] = null;
                     } else if (stack.stackSize != numItemsInStack) {
                         this.worldRenderer.itemRenderer.updateEquippedItem();
                     }
@@ -1348,7 +1335,7 @@ public class Minecraft
                     return;
                 }
                 if (stack.stackSize <= 0) {
-                    this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.getCurrentItemIndex()] = null;
+                    this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.getCurrentSlot()] = null;
                 } else if (stack.stackSize != numItemsInStack) {
                     this.worldRenderer.itemRenderer.resetEquippedProgress();
                 }
@@ -1474,7 +1461,7 @@ public class Minecraft
                             this.thePlayer.setFlySpeed(newSpeed);
                             this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(this.gameSettings.flightSpeed);
                         } else if (!this.gameSettings.keyZoom.isPressed()) {
-                            this.thePlayer.inventory.changeCurrentItem(scrollDelta);
+                            this.thePlayer.inventory.changeCurrentSlot(scrollDelta);
                         }
                     }
                     if (!this.inGameHasFocus && Mouse.getEventButtonState()) {
@@ -1546,7 +1533,7 @@ public class Minecraft
                                 forceReload();
                             } else if (this.gameSettings.keySwitchGamemode.isPressEvent()) {
                                 if (this.currentWorld.getLevelData().getCheatsEnabled() || this.currentWorld.isClientSide) {
-                                    if (this.thePlayer.getGamemode() == Gamemode.creative) {
+                                    if (this.thePlayer.getGamemode() == Gamemodes.CREATIVE) {
                                         this.thePlayer.sendChatMessage("/gamemode 0");
                                     } else {
                                         this.thePlayer.sendChatMessage("/gamemode 1");
@@ -1804,7 +1791,7 @@ public class Minecraft
         }
 
         // Fly
-        if (this.thePlayer.getGamemode().canPlayerFly() && this.gameSettings.keyFly.isPressEvent(currentInputDevice)) {
+        if (this.thePlayer.getGamemode().hasPlayerFlight() && this.gameSettings.keyFly.isPressEvent(currentInputDevice)) {
             if (!this.toggleFlyPressed) this.toggleFlyPressed = true;
             this.flyPressedTime = System.currentTimeMillis();
             return true;
@@ -1812,7 +1799,7 @@ public class Minecraft
 
         // Hotbar switch
         if (this.gameSettings.keyHotBarSwitch.isPressEvent(currentInputDevice)) {
-            if (!this.thePlayer.inventory.currentItemLocked()) {
+            if (!this.thePlayer.inventory.currentSlotLocked()) {
                 if (shift) {
                     this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + 27) % (36));
                     this.hotbarSwapAnimationProgress = -HOTBAR_SWAP_ANIMATION_LENGTH_TICKS;
@@ -1820,7 +1807,7 @@ public class Minecraft
                     this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + 9) % (36));
                     this.hotbarSwapAnimationProgress = HOTBAR_SWAP_ANIMATION_LENGTH_TICKS;
                 }
-                this.thePlayer.inventory.changeCurrentItem(0);
+                this.thePlayer.inventory.changeCurrentSlot(0);
             }
             return true;
         }
@@ -1898,13 +1885,13 @@ public class Minecraft
 
         // Hotbar left
         if (this.gameSettings.keyHotBarLeft.isPressEvent(currentInputDevice)) {
-            this.thePlayer.inventory.changeCurrentItem(1);
+            this.thePlayer.inventory.changeCurrentSlot(1);
             return true;
         }
 
         // Hotbar right
         if (this.gameSettings.keyHotBarRight.isPressEvent(currentInputDevice)) {
-            this.thePlayer.inventory.changeCurrentItem(-1);
+            this.thePlayer.inventory.changeCurrentSlot(-1);
             return true;
         }
 
@@ -1922,7 +1909,7 @@ public class Minecraft
         };
         for (int i = 0; i < hotbarSlots.length; i++) {
             if (hotbarSlots[i].isPressEvent(currentInputDevice)) {
-                this.thePlayer.inventory.setCurrentItemIndex(i + this.thePlayer.inventory.getHotbarOffset(), false);
+                this.thePlayer.inventory.setCurrentSlot(i + this.thePlayer.inventory.getHotbarOffset(), false);
                 return true;
             }
         }
@@ -1952,7 +1939,7 @@ public class Minecraft
     }
 
     private ScreenInventory getInventoryScreen() {
-        if (this.thePlayer.getGamemode() == Gamemode.creative) {
+        if (this.thePlayer.getGamemode() == Gamemodes.CREATIVE) {
             return new ScreenInventoryCreative(this.thePlayer);
         } else {
             return new ScreenInventory(this.thePlayer);
@@ -2001,27 +1988,27 @@ public class Minecraft
                 displayScreen(new ScreenPause());
             }
             if (controller.digitalPad.up.pressedThisFrame()) {
-                if (!this.thePlayer.inventory.currentItemLocked()) {
+                if (!this.thePlayer.inventory.currentSlotLocked()) {
                     this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + 27) % (36));
                     this.hotbarSwapAnimationProgress = -HOTBAR_SWAP_ANIMATION_LENGTH_TICKS;
-                    this.thePlayer.inventory.changeCurrentItem(0);
+                    this.thePlayer.inventory.changeCurrentSlot(0);
                 }
             }
             if (controller.digitalPad.down.pressedThisFrame()) {
-                if (!this.thePlayer.inventory.currentItemLocked()) {
+                if (!this.thePlayer.inventory.currentSlotLocked()) {
                     this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + 9) % (36));
                     this.hotbarSwapAnimationProgress = HOTBAR_SWAP_ANIMATION_LENGTH_TICKS;
-                    this.thePlayer.inventory.changeCurrentItem(0);
+                    this.thePlayer.inventory.changeCurrentSlot(0);
                 }
             }
-            if (controller.digitalPad.left.pressedThisFrame() && this.thePlayer.getGamemode().canPlayerFly()) {
+            if (controller.digitalPad.left.pressedThisFrame() && this.thePlayer.getGamemode().hasPlayerFlight()) {
                 this.thePlayer.setNoclip(!this.thePlayer.noPhysics);
             }
             if (controller.buttonLeftShoulder.pressedThisFrame()) {
-                this.thePlayer.inventory.changeCurrentItem(1);
+                this.thePlayer.inventory.changeCurrentSlot(1);
             }
             if (controller.buttonRightShoulder.pressedThisFrame()) {
-                this.thePlayer.inventory.changeCurrentItem(-1);
+                this.thePlayer.inventory.changeCurrentSlot(-1);
             }
             if (controller.joyLeft.getButton().pressedThisFrame()) {
                 this.gameSettings.thirdPersonView.value++;
@@ -2086,7 +2073,7 @@ public class Minecraft
         changeWorld(world, I18n.getInstance().translateKey("gui.loading.label.generating"));
 
         this.thePlayer.setGamemode(worldConfiguration.getGamemode());
-        if (worldConfiguration.getGamemode() == Gamemode.adventure) {
+        if (worldConfiguration.getGamemode() == Gamemodes.ADVENTURE) {
             this.thePlayer.inventory.insertItem(Items.TOOL_AXE_WOOD.getDefaultStack(), true);
         }
     }
@@ -2387,7 +2374,7 @@ public class Minecraft
         this.currentWorld.getRespawnLocation();
         this.currentWorld.updateEntityList();
         int j = 0;
-        Gamemode playerGamemode = Gamemode.survival;
+        Gamemode playerGamemode = Gamemodes.SURVIVAL;
         if (this.thePlayer != null) {
             j = this.thePlayer.id;
             this.currentWorld.setEntityDead(this.thePlayer);
@@ -2398,7 +2385,7 @@ public class Minecraft
         this.thePlayer.setGamemode(playerGamemode);
         if (previousPlayer != null && previousPlayer.getHeldObject() != null) {
             this.thePlayer.setHeldObject(previousPlayer.getHeldObject());
-            this.thePlayer.inventory.setCurrentItemIndex(previousPlayer.inventory.getCurrentItemIndex(), true);
+            this.thePlayer.inventory.setCurrentSlot(previousPlayer.inventory.getCurrentSlot(), true);
             this.thePlayer.inventory.setHotbarOffset(previousPlayer.inventory.getHotbarOffset(), true);
         }
         this.activeCamera = new EntityCameraFirstPerson(this, this.thePlayer);
@@ -2648,7 +2635,7 @@ public class Minecraft
     }
 
     public boolean canRenderEntityLabel() {
-        return isDebugInfoEnabled() && this.thePlayer != null && this.thePlayer.getGamemode() == Gamemode.creative;
+        return isDebugInfoEnabled() && this.thePlayer != null && this.thePlayer.getGamemode() == Gamemodes.CREATIVE;
     }
 
     public float getOutlineWidth() {
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 3acee0969..522cbf632 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -102,16 +102,16 @@ public class PlayerLocal extends Player {
     public void setGamemode(Gamemode gamemode) {
         this.gamemode = gamemode;
 
-        MenuInventory newContainer = gamemode.getContainer(this.inventory, !this.world.isClientSide);
+        MenuInventory newContainer = gamemode.getInventoryMenu(this.inventory);
         if (this.craftingInventory == this.inventorySlots) {
             this.craftingInventory = newContainer;
         }
         this.inventorySlots = newContainer;
-        if (!gamemode.canPlayerFly()) {
+        if (!gamemode.hasPlayerFlight()) {
             this.noPhysics = false;
         }
 
-        this.fireImmune = gamemode.isImmuneToFire();
+        this.fireImmune = gamemode.hasFireImmunity();
     }
 
     @Override
@@ -147,7 +147,7 @@ public class PlayerLocal extends Player {
                 this.mc.sndManager.playSound("portal.trigger", SoundCategory.WORLD_SOUNDS, 1.0F, this.random.nextFloat() * 0.4F + 0.8F);
             }
             this.timeInPortal += 0.0125F;
-            if (this.timeInPortal >= 1.0F || getGamemode().instantPortalTravel()) {
+            if (this.timeInPortal >= 1.0F || getGamemode().hasInstantPortalTravel()) {
                 this.timeInPortal = 1.0F;
                 if (!this.world.isClientSide) {
                     this.timeUntilPortal = 10;
@@ -315,7 +315,7 @@ public class PlayerLocal extends Player {
     }
 
     public int getPlayerProtectionAmount() {
-        return this.inventory.getTotalArmourPoints();
+        return this.inventory.getTotalArmorPoints();
     }
 
     public void sendChatMessage(String s) {
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
index b9d846ee7..e13fb7229 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
@@ -126,7 +126,7 @@ public class PlayerRemote extends Player
         }
         if(slot == 0)
         {
-            inventory.mainInventory[inventory.getCurrentItemIndex()] = itemstack;
+            inventory.mainInventory[inventory.getCurrentSlot()] = itemstack;
         } else
         {
             inventory.armorInventory[slot - 1] = itemstack;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
index 92f4bf44c..9f445687c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
@@ -34,7 +34,7 @@ public class HeldItemTooltipElement extends Gui {
 			ItemStack item = mc.thePlayer.getCurrentEquippedItem();
 			
 			int id = getItemID(item);
-			int i = mc.thePlayer.inventory.getCurrentItemIndex();
+			int i = mc.thePlayer.inventory.getCurrentSlot();
 			
 			if(id != this.lastItemID || i != this.lastSelectedItem) {
 				updateString(item);
@@ -53,7 +53,7 @@ public class HeldItemTooltipElement extends Gui {
 			ItemStack item = mc.thePlayer.getCurrentEquippedItem();
 
 			int id = getItemID(item);
-			int i = mc.thePlayer.inventory.getCurrentItemIndex();
+			int i = mc.thePlayer.inventory.getCurrentSlot();
 
 			if(id != this.lastItemID || i != this.lastSelectedItem) {
 				updateString(item);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
index 317689809..b438c7791 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
@@ -1,24 +1,24 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.gui.popup.PopupScreen;
-import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.gui.worldsettings.ScreenWorldSettings;
-import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.player.gamemode.Gamemode;
-import net.minecraft.core.world.Dimension;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.world.settings.WorldConfiguration;
-import net.minecraft.core.world.type.WorldTypeGroups;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 
+import java.util.ArrayList;
 import java.util.List;
 
 public class ScreenCreateWorld extends Screen {
-    private int overrideSpawnX;
-    private int overrideSpawnY;
-    private int overrideSpawnZ;
+    public static final @NotNull List<@NotNull Gamemode> GAMEMODES = new ArrayList<>();
+    static {
+        GAMEMODES.add(Gamemodes.SURVIVAL);
+        GAMEMODES.add(Gamemodes.CREATIVE);
+        GAMEMODES.add(Gamemodes.HARDCORE);
+        GAMEMODES.add(Gamemodes.ADVENTURE);
+    }
     private TextFieldElement textboxWorldName;
     private TextFieldElement textboxSeed;
     private ButtonElement createWorldButton;
@@ -86,9 +86,8 @@ public class ScreenCreateWorld extends Screen {
 
             this.mc.displayScreen(null);
         } else if (button == this.gamemodeButton) {
-            List<Gamemode> gamemodeList = Gamemode.getPublicGamemodes();
-            this.worldConfiguration.setGamemode(gamemodeList.get((gamemodeList.indexOf(this.worldConfiguration.getGamemode()) + 1) % gamemodeList.size()));
-            this.worldConfiguration.setCheatsEnabled(this.worldConfiguration.getGamemode() == Gamemode.creative);
+            this.worldConfiguration.setGamemode(GAMEMODES.get((GAMEMODES.indexOf(this.worldConfiguration.getGamemode()) + 1) % GAMEMODES.size()));
+            this.worldConfiguration.setCheatsEnabled(this.worldConfiguration.getGamemode() == Gamemodes.CREATIVE);
             syncButtons();
         } else if (button == this.cheatsButton) {
             this.worldConfiguration.setCheatsEnabled(!this.worldConfiguration.getCheatsEnabled());
@@ -165,14 +164,4 @@ public class ScreenCreateWorld extends Screen {
             this.textboxSeed.setFocused(false);
         }
     }
-
-    public void runPreset(String name, String seed, int spawnX, int spawnY, int spawnZ) {
-        this.overrideSpawnX = spawnX;
-        this.overrideSpawnY = spawnY;
-        this.overrideSpawnZ = spawnZ;
-        this.worldConfiguration.setWorldName(name);
-        this.worldConfiguration.setStringSeed(seed);
-        this.worldConfiguration.setGamemode(Gamemode.creative);
-        buttonClicked(this.createWorldButton);
-    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenGameOver.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
index 7713cee48..bcc8910ef 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
@@ -4,7 +4,7 @@ import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.packet.PacketKeepAlive;
-import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import org.jetbrains.annotations.NotNull;
 
 import net.minecraft.core.net.command.TextFormatting;
@@ -27,7 +27,7 @@ public class ScreenGameOver extends Screen {
     public void init() {
         I18n i18n = I18n.getInstance();
         this.buttons.clear();
-        String respawnKey = (this.mc.thePlayer.getGamemode() == Gamemode.hardcore || this.mc.thePlayer.getGamemode() == Gamemode.spectator) ? "gui.game_over.button.respawn.spectator" : "gui.game_over.button.respawn";
+        String respawnKey = (this.mc.thePlayer.getGamemode() == Gamemodes.HARDCORE || this.mc.thePlayer.getGamemode() == Gamemodes.SPECTATOR) ? "gui.game_over.button.respawn.spectator" : "gui.game_over.button.respawn";
         this.buttons.add(new ButtonElement(1, this.width / 2 - 100, this.height / 4 + 72, i18n.translateKey(respawnKey)));
         this.buttons.add(new ButtonElement(2, this.width / 2 - 100, this.height / 4 + 96, i18n.translateKey("gui.game_over.button.title_screen")));
         if (this.mc.session == null) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
index 2f3353b6e..be2276fa4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
@@ -1,12 +1,17 @@
 package net.minecraft.client.gui;
 
 import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.IntTag;
+import com.mojang.nbt.tags.StringTag;
+import com.mojang.nbt.tags.Tag;
 import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.Global;
+import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.util.helper.MathHelper;
@@ -293,11 +298,19 @@ public class ScreenSelectWorld extends Screen {
             SaveFile saveFile = ScreenSelectWorld.this.saveList.get(index);
 
             CompoundTag userTag = ScreenSelectWorld.this.userTags.get(saveFile);
-            Gamemode gamemode;
+            Gamemode gamemode = null;
             if (userTag != null) {
-                gamemode = Gamemode.gamemodesList[userTag.getInteger("Gamemode")];
-            } else {
-                gamemode = Gamemode.survival;
+                final @Nullable Tag<?> gamemodeTag = userTag.getTag("Gamemode");
+                if (gamemodeTag != null) {
+                    if (gamemodeTag instanceof final @NotNull StringTag stringTag) {
+                        gamemode = Registries.GAMEMODES.getItem(stringTag.getValue());
+                    } else if (gamemodeTag instanceof final @NotNull IntTag intTag) {
+                        gamemode = Gamemodes.getGamemodeByLegacyId(intTag.getValue());
+                    }
+                }
+            }
+            if (gamemode == null) {
+                gamemode = Gamemodes.SURVIVAL;
             }
 
             final String saveName = saveFile.getDisplayName();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index a238adc9a..4884fd5f0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -258,7 +258,7 @@ public abstract class ScreenContainerAbstract extends Screen {
 
     @Override
     public void mouseClicked(final int mx, final int my, int buttonNum) {
-        if (!this.mc.thePlayer.getGamemode().consumeBlocks()) {
+        if (!this.mc.thePlayer.getGamemode().hasBlockConsumption()) {
             // Duplicate items with middle mouse button
             if (buttonNum == 2) {
                 Slot slot = this.inventorySlots.getSlot(getSlotId(mx, my));
@@ -309,7 +309,7 @@ public abstract class ScreenContainerAbstract extends Screen {
             return;
         }
 
-        if (!this.mc.thePlayer.getGamemode().consumeBlocks()) {
+        if (!this.mc.thePlayer.getGamemode().hasBlockConsumption()) {
             // Duplicate items with middle mouse button
             if (mouseButton == 2) {
                 Slot slot = this.inventorySlots.getSlot(slotId);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
index 00e62e2f1..eeec84b0b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
@@ -19,9 +19,9 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.client.option.GameSettings;
-import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.EntityRendererDispatcher;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import org.jetbrains.annotations.NotNull;
 
 import net.minecraft.core.util.helper.Color;
@@ -86,7 +86,7 @@ public class ScreenInventory extends ScreenContainerAbstract {
         boolean compass = false;
         boolean rotaryCalendar = false;
 
-        if (this.mc.thePlayer.getGamemode() == Gamemode.creative) {
+        if (this.mc.thePlayer.getGamemode() == Gamemodes.CREATIVE) {
             clock = true;
             compass = true;
             rotaryCalendar = true;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/SlotGuidebook.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/SlotGuidebook.java
index 279951503..5775a1cb2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/SlotGuidebook.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/SlotGuidebook.java
@@ -10,7 +10,7 @@ import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.player.inventory.slot.Slot;
 import org.jetbrains.annotations.Nullable;
 
@@ -121,7 +121,7 @@ public class SlotGuidebook extends Slot
 			Minecraft mc = Minecraft.getMinecraft();
 			if (!mc.gameSettings.hideUndiscoveredItems.value) return true;
 		}
-		return player.getStat(item.getItem().getStat(StatList.STAT_PICKED_UP)) > 0 || player.getGamemode() == Gamemode.creative;
+		return player.getStat(item.getItem().getStat(StatList.STAT_PICKED_UP)) > 0 || player.getGamemode() == Gamemodes.CREATIVE;
 	}
 
 	public void scrollRecipe(){
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
index f9d5ccfa4..fbe0adaa0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
@@ -20,7 +20,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.client.gui.guidebook.SlotGuidebook;
 import net.minecraft.core.util.helper.MathHelper;
@@ -109,7 +109,7 @@ public class GuidebookPageMob
     protected void renderForeground(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(this.mobClass);
         this.discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(entry != null ? entry.namespaceID : null)) > 0;
-        if (mc.thePlayer.getGamemode() == Gamemode.creative || !mc.gameSettings.hideUndiscoveredItems.value)
+        if (mc.thePlayer.getGamemode() == Gamemodes.CREATIVE || !mc.gameSettings.hideUndiscoveredItems.value)
             this.discovered = true;
 
         Lighting.disable();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookSectionMob.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookSectionMob.java
index 75bb57e40..20ab809d3 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookSectionMob.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookSectionMob.java
@@ -6,13 +6,12 @@ import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.gui.guidebook.SearchableGuidebookSection;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.collection.Pair;
 
 import java.util.ArrayList;
@@ -91,7 +90,7 @@ public class GuidebookSectionMob
         	Minecraft mc = Minecraft.getMinecraft();
             EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(mobInfo.getEntityClass());
             boolean discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(entry != null ? entry.namespaceID : null)) > 0;
-            if (mc.thePlayer.getGamemode() == Gamemode.creative) discovered = true;
+            if (mc.thePlayer.getGamemode() == Gamemodes.CREATIVE) discovered = true;
 
             if (discovered) {
                 return I18n.getInstance().translateKey(mobInfo.getNameTranslationKey());
